//Piroli by SMS Alfredo
--
//Code snippets borrowed from sloperollangle by Golden
//https://mb.srb2.org/threads/sloperollangle-character-rotation-on-slopes.27164/
//As well as Fang Popgun Modifications by CobaltBW
--
//Diamond sparkle effect edited from DirkTheHusky's Mario's stars with permission
//https://mb.srb2.org/addons/super-mario.3420/

sfxinfo[freeslot("sfx_prlrun")].caption = "/"
sfxinfo[freeslot("sfx_prlbnk")].caption = "Bonk"
sfxinfo[freeslot("sfx_prlrtn")].caption = "/"
sfxinfo[freeslot("sfx_prlslc")].caption = "Slice"
sfxinfo[freeslot("sfx_prlthw")].caption = "Throw"

local pirolirollangle = CV_RegisterVar({
	name = "pirolirollangle",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

// Abilites table for Kirby to eat
if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
// Needle
kirbyabilitytable["piroli"] = 6

local SQUISHTIME = 6

//Can't move conditions
local function CantMove(player)
	local mo = player.mo
	return not (mo and mo.valid and mo.skin == "piroli")
	or P_PlayerInPain(player)
	or (player.panim == PA_PAIN and not (player.pflags & PF_JUMPED))
	or player.pflags & PF_SLIDING
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not mo.health
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and mo.state == S_PLAY_FACEPLANT)
end

//Reset Piroli
local function ResetPiroli(player)
	player.pirolifriction = 0
	player.pirolipressspin = false
	player.pirolirunsound = false
	player.pirolilanding = 0
	player.piroliprevdrawangle = player.drawangle
		
	if player.pirolirollangle and player.mo and player.mo.valid
		player.mo.rollangle = 0
	end
	player.pirolirollangle = 0
		
	player.pirolireset = true
end
addHook("PlayerSpawn", ResetPiroli)
for player in players.iterate ResetPiroli(player) end

//EnemyLookDeluxe isn't treating me kindly...
//so I'm just gonna use the one from Fang Popgun Modifications by CobaltBW
local function newNeedleLook(player) 
	local twod = (twodlevel or player.mo.flags2 & MF2_TWOD)
	local ringdist, span
	ringdist = RING_DIST*2
	if not(twod)
		span = ANG30
	else
		span = ANG20
	end

	local maxdist = FixedMul(ringdist, player.mo.scale)
	local closestdist = 0
	local closestmo = nil
	searchBlockmap("objects",function(pmo,mo)
		if (mo.flags & MF_NOCLIPTHING) return end
		if (mo.health <= 0) return end -- dead

		if not(mo.player)
		and not(mo.flags & (MF_SPRING|MF_SOLID))
		and (!((mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)
		and (mo.flags & MF_SHOOTABLE)) or (mo.flags & MF_SPRING)) == !(mo.flags2 & MF2_INVERTAIMABLE)) -- allows if it has the flags desired XOR it has the invert aimable flag
			return -- not a valid target
		end

		if (mo == pmo) return end
		if (mo.flags2 & MF2_FRET) return end
		if (mo.type == MT_STEAM) return end
		if mo.player and 
			(
			mo.player.spectator
			or G_GametypeHasTeams() and mo.player.ctfteam == player.ctfteam
			)
		then return end //Disallow targeting teammates


		//Do angle/distance checks
		local zdist = (pmo.z + pmo.height/2) - (mo.z + mo.height/2)
		local dist = P_AproxDistance(pmo.x-mo.x, pmo.y-mo.y)
		//CBW: 	Made the angle checks their own locals, for readability purposes
		//		I also unsigned the angle checks, which appears to correct failed OutOfBounds checks above the player.
		local xyz_angle = abs(R_PointToAngle2(0, 0, dist, zdist))
		local xy_angle = abs(R_PointToAngle2(
				pmo.x + P_ReturnThrustX(pmo, pmo.angle, pmo.radius),
				pmo.y + P_ReturnThrustY(pmo, pmo.angle, pmo.radius),
				mo.x, mo.y
			) - pmo.angle)
			
			
		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist)
			return -- out of range
		end
		if (xyz_angle > span)
			return -- Don't home outside of desired angle!
		end


		if (twod
		and abs(pmo.y-mo.y) > pmo.radius)
			return -- not in your 2d plane
		end

		if ((closestmo and closestmo.valid) and (dist > closestdist))
			return
		end
		if (xy_angle > span)
			return -- behind back
		end

		if not (P_CheckSight(pmo, mo))
			return -- out of sight
		end

		closestmo = mo
		closestdist = dist
	end,player.mo,player.mo.x-maxdist,player.mo.x+maxdist,player.mo.y-maxdist,player.mo.y+maxdist)
	return closestmo
end

//Spawns objects in a circle
local pirolicircle = function(mobj, mobjtype, amount, ns, zoffset, scale, keepmom, color, vertical, vertangle)
	if not amount then return end
	local i = 0	while i < amount
		local fa = i*(ANGLE_180/(amount/2)) + (vertangle or 0)
		local mo = P_SpawnMobjFromMobj(mobj,0,0,zoffset,mobjtype)
		if mo and mo.valid
			local height = mo.height
			mo.scale = scale
			
			if mo.flags & MF_MISSILE
				mo.target = mobj
			end
			
			if mobjtype == MT_MINECARTSPARK
				mo.fuse = TICRATE/2
				
			//Sprite based off DirkTheHusky's Mario's star effect with permission
			elseif mo.type == MT_GHOST
				mo.state = S_INVISIBLE
				mo.sprite = SPR_PIRO
				mo.frame = FF_FULLBRIGHT|B
				mo.tics = 14
				
				mo.flags = mobjinfo[MT_THOK].flags &~ MF_NOGRAVITY
				mo.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
				mo.color = SKINCOLOR_SKY
				mo.blendmode = AST_ADD
			end
			
			if mobj.eflags&MFE_VERTICALFLIP
				mo.z = $ - (mo.height-height)
			end
			
			if color
				mo.color = color
				if mobjtype != MT_GHOST
					mo.colorized = true
				end
			end
			
			if vertical
				mo.momz = FixedMul(sin(fa),ns)
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns))
			else
				mo.momx = FixedMul(cos(fa),ns)
				mo.momy = FixedMul(sin(fa),ns)
				mo.angle = fa
			end
			
			if keepmom == -1
				mo.momx = $ + mobj.momx*2/3
				mo.momy = $ + mobj.momy*2/3
				mo.momz = $ + P_GetMobjGravity(mobj)*8
			elseif keepmom
				if keepmom == true then keepmom = 1 end
				mo.momx = $ + mobj.momx/keepmom
				mo.momy = $ + mobj.momy/keepmom
				mo.momz = $ + mobj.momz/keepmom
			end
			
			if mo.type == MT_GHOST
				mo.momx = $ + P_RandomRange(-24, 24)*mo.scale/6
				mo.momy = $ + P_RandomRange(-24, 24)*mo.scale/6
				mo.momz = $ + P_RandomRange(2, 24)*mo.scale/3
				if not vertical P_SetObjectMomZ(mo, 4*FRACUNIT, true) end
			end
		end
		i = $ + 1
	end
end

//Needle Latching
function A_PiroliLatch(mobj, var1, var2)
	local mo = mobj.target
	local player = mo and mo.valid and mo.player
	
	//Let's apply the missile explosion flags in case they weren't already
	mobj.flags = $ | MF_NOCLIPTHING &~ MF_MISSILE
	
	//Break floors
	local nobust = true
	if mobj.subsector and mobj.subsector.valid
	and mobj.subsector.sector and mobj.subsector.sector.valid
		for fof in mobj.subsector.sector.ffloors()
			if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
			if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
			
			if mobj.z + mobj.momz + mobj.height < fof.bottomheight continue end -- Are we too low?
			if mobj.z + mobj.momz > fof.topheight continue end -- Are we too high?  
			
			EV_CrumbleChain(fof) -- Crumble
			if fof.master.flags & ML_EFFECT5
				P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, fof.target)
			end
			
			nobust = false
		end
	end
	
	//Move forward into the wall
	local amount = 4
	local speed = FixedMul(mobj.info.speed, mobj.scale)/amount
	for i = 1, amount
		P_TryMove(mobj, mobj.x + P_ReturnThrustX(mobj, mobj.angle, speed),
		mobj.y + P_ReturnThrustY(mobj, mobj.angle, speed), true)
	end
	
	//Do the momentum!
	local sound = mobj.info.attacksound
	if player and not CantMove(player)
		if player.pirolipressspin
			sound = mobj.info.painsound
			
			mo.momx = $/2
			mo.momy = $/2
			P_Thrust(mo, R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y), 40*mo.scale)
			
			mo.momz = $/2 + FixedMul(mobj.z - mo.z, abs(P_GetMobjGravity(mo)))/6
			if P_IsObjectOnGround(mo) and mo.momz*P_MobjFlip(mo) > 0
				mo.z = $ + P_MobjFlip(mo)
				player.pflags = $ | P_GetJumpFlags(player)
			end
			
			player.pirolisquish = -SQUISHTIME
			
			//Friction
			mo.friction = FRACUNIT
			player.pirolifriction = TICRATE*2/3
			player.powers[pw_noautobrake] = player.pirolifriction
		else
			mobj.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT
		end
	end
	
	mobj.fuse = TICRATE/3
	mobj.cusval = 2
	
	//Dust
	pirolicircle(mobj, MT_DUST, 8, 6*mo.scale,
	mobj.info.height/2, mobj.scale, 0, nil, nobust, mobj.angle)
	
	pirolicircle(mobj, MT_GHOST, 8, 4*mo.scale,
	mobj.info.height/2, mobj.scale/2, 0, nil, nobust, mobj.angle)
	
	//Sound
	if player == displayplayer
		S_StartSound(nil, sound)
	else
		S_StartSound(mobj, sound)
	end
	S_StopSoundByID(mo, mobj.info.seesound)
end

//Needle Definition
states[freeslot("S_PIROLI_NEEDLE")] = {freeslot("SPR_PIRO"), 0|FF_PAPERSPRITE, -1, A_PiroliLatch, 0, 0, S_NULL}
mobjinfo[freeslot("MT_PIROLI_NEEDLE")] = {
	spawnstate = S_PIROLI_NEEDLE, //Haha, spawn states don't run actions!
	deathstate = S_PIROLI_NEEDLE,
	spawnhealth = 1000,
	seesound = sfx_prlthw,
	painsound = sfx_prlslc,
	deathsound = sfx_prlrtn,
	attacksound = sfx_prlbnk,
	speed = 40*FRACUNIT,
	radius = 24*FRACUNIT,
	height = 8*FRACUNIT,
	mass = DMG_SPIKE,
	damage = 1,
	flags = MF_MISSILE|MF_NOGRAVITY,
}

//Needle Thinker
addHook("MobjThinker", function(mobj)
	local mo = mobj.target
	local player = mo and mo.valid and mo.player
	local hitsomething = false
	local numLineMobjs = 32
	
	mobj.reactiontime = $ + 1
	
	//MobjSpawn
	if not mobj.threshold
		mobj.shadowscale = FRACUNIT/2
		mobj.fuse = 15
		
		mobj.threshold = (leveltime & 1) and -1 or 1
		mobj.movedir = R_PointToAngle2(0,0, FixedHypot(mobj.momx, mobj.momy), mobj.momz)
		
		mobj.color = player and player.skincolor or SKINCOLOR_LAVENDER
		
		//Make line
		mobj.piroliline = {}
		for i = 1, numLineMobjs
			local part = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_CYBRAKDEMON_TARGET_DOT)
			
			part.frame = $ &~ FF_TRANSMASK &~ FF_FULLBRIGHT
			part.tics = -1
			part.spriteyscale = $/2
			
			part.colorized = true
			if (i/4) & 1
				part.color = mobj.color
			else
				part.color = SKINCOLOR_SUPERGOLD2
			end
				
			table.insert(mobj.piroliline, part)
		end
		
	//Rail movement
	elseif not mobj.cusval
	and not (mobj.flags2 & MF2_AMBUSH and player and not (player.pflags & PF_SPINDOWN))
		hitsomething = P_RailThinker(mobj)
	end
	
	if not (mobj and mobj.valid) then return end
	if not mobj.cusval and (hitsomething or P_IsObjectOnGround(mobj))
		P_ExplodeMissile(mobj)
	end
	
	//Rollangle junk
	mobj.rollangle = mobj.movedir
	mobj.spriteyoffset = mobj.movedir/UINT8_MAX
	local camangle = R_PointToAngle(mobj.x, mobj.y)
	if displayplayer and displayplayer.valid
		camangle = displayplayer.cmd.angleturn<<16
	end
	local diff = mobj.angle - camangle
	if diff > 0
		mobj.rollangle = InvAngle($)
	end
	
	//Player junk
	if not player then return end
	
	//Return to the player
	if not mobj.cusval and mobj.flags2 & MF2_AMBUSH
	and not (player.pflags & PF_SPINDOWN)
		mobj.fuse = 1
	elseif mobj.flags & MF_NOCLIP and mobj.fuse
		local factor = mobj.fuse
		P_TeleportMove(mobj, mobj.x - (mobj.x - mo.x)/factor,
		mobj.y - (mobj.y - mo.y)/factor,
		mobj.z - (mobj.z - mo.z - mo.height/2)/factor)
		
		mobj.angle = R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y)
	end
	
	if mobj.cusval != 2 and mobj.flags & MF_MISSILE and mobj.flags2 & MF2_AMBUSH
		P_TryMove(mobj, mobj.x + mo.momx, mobj.y + mo.momy, true)
		mobj.z = $ + mo.momz
		if P_IsObjectOnGround(mobj) then P_ExplodeMissile(mobj) end
	end
	
	//Stuff
	if P_MobjFlip(mo) < 0
		mobj.flags2 = $ | MF2_OBJECTFLIP
		mobj.eflags = $ | MFE_VERTICALFLIP
	else
		mobj.flags2 = $ &~ MF2_OBJECTFLIP
		mobj.eflags = $ &~ MFE_VERTICALFLIP
	end
	mobj.destscale = mo.destscale
	
	//Draw the line
	if not mobj.piroliline or not #mobj.piroliline then return end
	
	local xoffset = P_ReturnThrustX(nil, player.drawangle, 10*mobj.scale)
	+ P_ReturnThrustX(nil, mobj.angle, -mobj.radius*2) + mobj.x + mobj.momx
	local yoffset = P_ReturnThrustY(nil, player.drawangle, 10*mobj.scale)
	+ P_ReturnThrustY(nil, mobj.angle, -mobj.radius*2) + mobj.y + mobj.momy

	// Now draw the line to the object from the tracer
	numLineMobjs = #mobj.piroliline

	// Get distance for each step
	local distX = (xoffset - mo.x) / numLineMobjs
	local distY = (yoffset - mo.y) / numLineMobjs
	local distZ = (mobj.z + mobj.momz - mo.z - mo.height/2) / numLineMobjs
	if P_MobjFlip(mo) < 0
		distZ = (mobj.z + mobj.momz + mobj.height - mo.z - mo.height/2) / numLineMobjs
	end
	
	for i, part in pairs(mobj.piroliline) do
		if not (part and part.valid and part.type == MT_CYBRAKDEMON_TARGET_DOT) then continue end
		
		P_TeleportMove(part, mo.x + distX * i, mo.y + distY * i,
		mo.z + mo.height/2 + distZ * i + 4*part.scale*P_MobjFlip(mo))
		
		//Wavy
		if mobj.cusval != 2
			local multiplier = numLineMobjs/2 - abs(numLineMobjs/2 - i)
			
			//Horizontal
			local horizontal = FixedMul(sin((i+mobj.reactiontime)*3*(ANGLE_180/numLineMobjs)), mo.scale)
			horizontal = $*multiplier*3/2
			P_TryMove(part, part.x + P_ReturnThrustX(part, mobj.angle + ANGLE_90, horizontal),
			part.y + P_ReturnThrustY(part, mobj.angle + ANGLE_90, horizontal), true)
		end
	end
end, MT_PIROLI_NEEDLE)

addHook("MobjRemoved", function(mobj)
	if not mobj.piroliline then return end
	
	for i, part in pairs(mobj.piroliline) do
		if part and part.valid and part.type == MT_CYBRAKDEMON_TARGET_DOT
			P_RemoveMobj(part)
		end
	end
end, MT_PIROLI_NEEDLE)

//Egg Wall Breaker Function
local eggwallbreak = function(mobj, sectorthing)
	local nerds = false
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, fof.target)
				end
				return true
			end
		end
	end
end

//Egg Wall Breaker
addHook("MobjLineCollide", function(mobj, line)
	local killone, killtwo
	if not (line and line.valid and mobj and mobj.valid) then return end
	if line.frontsector and line.frontsector.valid then killone = eggwallbreak(mobj, line.frontsector) end
	if line.backsector and line.backsector.valid then killtwo = eggwallbreak(mobj, line.backsector) end
	if killone or killtwo then return true end
end, MT_PIROLI_NEEDLE)

//Destroy spikes, collect rings, and hit springs
addHook("MobjMoveCollide", function(mobj, target)
	if mobj.target and mobj.target.valid and mobj.target.player
	and mobj.flags & MF_MISSILE
	and (target.type == MT_SPIKE or target.type == MT_WALLSPIKE
	or target.type == MT_RING or target.type == MT_COIN
	or target.type == MT_FLINGRING or target.type == MT_FLINGCOIN
	or (target.type == MT_REDTEAMRING and mobj.target.player.ctfteam == 1)
	or (target.type == MT_BLUETEAMRING and mobj.target.player.ctfteam == 2)
	or target.type == MT_NIGHTSSTAR or target.flags & MF_SPRING)
	and mobj.z - mobj.scale <= target.z + target.height
	and mobj.z + mobj.height + mobj.scale >= target.z
		if target.flags & MF_SPRING
			return true
		else
			P_KillMobj(target, mobj, mobj.target)
			if target.type == MT_SPIKE or target.type == MT_WALLSPIKE
				P_RailThinker(mobj)
				if mobj and mobj.valid
					P_ExplodeMissile(mobj)
				end
			else
				P_GivePlayerRings(mobj.target.player, 1)
				if target.info.deathsound == sfx_rnglft
				or target.info.deathsound == sfx_rngrgh
					target.info.deathsound = sfx_itemup
				end
				S_StartSound(target, target.info.deathsound)
				target.momx = 0
				target.momy = 0
				target.momz = 0
				
				if mapheaderinfo[gamemap].typeoflevel&TOL_NIGHTS
				and target.type != MT_FLINGRING and target.type != MT_FLINGCOIN
					P_DoNightsScore(mobj.target.player)
				end
			end
		end
	end
end, MT_PIROLI_NEEDLE)

//Hit enemies
addHook("MobjDamage", function(target, mobj)
	if mobj and mobj.valid and mobj.type == MT_PIROLI_NEEDLE
		P_ExplodeMissile(mobj)
	end
end)

//Needle fuse
addHook("MobjFuse", function(mobj)
	if not mobj.cusval
		mobj.fuse = 5
		mobj.cusval = 1
		
		return true
	elseif not (mobj.flags & MF_NOCLIP)
		mobj.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT | MF_NOCLIPTHING &~ MF_MISSILE
		mobj.fuse = TICRATE/3
		A_ForceStop(mobj)
		
		S_StartSound(mobj, mobj.info.deathsound)
		
		return true
	end
end, MT_PIROLI_NEEDLE)

//Flight
addHook("AbilitySpecial", function(player)	
	local mo = player.mo
	if CantMove(player) then return end
	if player.pflags & (PF_JUMPSTASIS|PF_SHIELDABILITY)
	or player.glidetime
	or player.secondjump > (player.actionspd >> FRACBITS) + 1
	then return true end
	
	if not (player.pflags & PF_THOKKED) then player.secondjump = 0 end
	player.secondjump = min($ + 1, (player.actionspd >> FRACBITS) + 1)
	player.pflags = $ | PF_THOKKED
	player.glidetime = 4
	
	S_StartSound(mo, sfx_cdfm17)
	mo.state = S_PLAY_JUMP
	mo.state = S_PLAY_TWINSPIN
	
	return true
end)

//Throwing needle
addHook("SpinSpecial", function(player)
	local mo = player.mo
	if CantMove(player) then return end
	if player.pflags & (PF_STASIS|PF_SPINDOWN)
	or player.exiting or P_SuperReady(player)
	or not (P_IsObjectOnGround(mo) or player.pflags & PF_JUMPED)
	or player.weapondelay or player.pirolifriction
	then return true end
	
	mo.state = S_PLAY_JUMP
	mo.state = S_PLAY_MELEE
	player.pirolisquish = -SQUISHTIME
	
	player.pirolipressspin = true
	player.weapondelay = 7
	
	//Remove old needle
	if player.pirolineedle and player.pirolineedle.valid
		P_RemoveMobj(player.pirolineedle)
	end
	
	//Spawn it!
	local enemy
	if FixedHypot(player.cmd.forwardmove, player.cmd.sidemove) < 35
		enemy = newNeedleLook(player)
	end
	if enemy and enemy.valid
		player.pirolineedle = P_SpawnMissile(mo, enemy, MT_PIROLI_NEEDLE)
	else
		local bustable = false
		if P_IsObjectOnGround(mo) and mo.subsector and mo.subsector.valid
		and mo.subsector.sector and mo.subsector.sector.valid
			for fof in mo.subsector.sector.ffloors()
				if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
				if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
				
				if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
				if mo.z + mo.momz > fof.topheight continue end -- Are we too high?
				
				bustable = true
			end
		end
		if bustable
			player.pirolineedle = P_SPMAngle(mo, MT_PIROLI_NEEDLE, mo.angle, 0, MF2_AMBUSH)
			player.pirolineedle.momz = FixedHypot(player.pirolineedle.momx, player.pirolineedle.momy)/-4
			player.pirolineedle.momx = $*3/4
			player.pirolineedle.momy = $*3/4
			player.pirolipressspin = false
		else
			player.pirolineedle = P_SPMAngle(mo, MT_PIROLI_NEEDLE, mo.angle, 0, MF2_AMBUSH)
		end
	end
	
	//Face needle
	if player.pirolineedle and player.pirolineedle.valid
		player.drawangle = R_PointToAngle2(mo.x,mo.y,player.pirolineedle.x,player.pirolineedle.y)
	end
end)

//Damage after needle lands
addHook("PlayerCanDamage", function(player)
	if not CantMove(player) and player.pirolifriction
		return true
	end
end)

//Main thinker
addHook("PlayerThink", function(player)
	local mo = player.mo
	
	//Squishy
	if mo and mo.valid
		if player.pirolisquish
			if player.pirolisquish > 0
				player.pirolisquish = $ - 1
			else
				player.pirolisquish = $ + 1
			end
			local factor = 12
			if abs(player.pirolisquish) <= SQUISHTIME/3 then factor = $*4
			elseif abs(player.pirolisquish) <= SQUISHTIME*2/3 then factor = $*2 end
			mo.spritexscale = FRACUNIT - sin(player.pirolisquish*ANGLE_45)/factor
			mo.spriteyscale = FRACUNIT + sin(player.pirolisquish*ANGLE_45)/factor
		end
			
		if mo.skin == "piroli" and not P_IsObjectOnGround(mo)
			local momz = min(mo.momz*P_MobjFlip(mo), 0)
			if player.pirolisquish
				mo.spritexscale = $ + FixedDiv(momz/UINT8_MAX, mo.scale)
				mo.spriteyscale = $ - FixedDiv(momz/UINT8_MAX, mo.scale)
			else
				mo.spritexscale = FRACUNIT + FixedDiv(momz/UINT8_MAX, mo.scale)
				mo.spriteyscale = FRACUNIT - FixedDiv(momz/UINT8_MAX, mo.scale)
				player.pirolisquish = nil
			end
		elseif player.pirolisquish == nil
			player.pirolisquish = 0
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
		end
	end
	
	//Prevent the rest of the code
	if CantMove(player)
		if not player.pirolireset
			ResetPiroli(player)
		end
		return
	end
	player.pirolireset = false
	
	if mo.state == S_PLAY_JUMP and player.pflags & PF_STARTJUMP
	and player.pflags & PF_JUMPED and player.pflags & PF_NOJUMPDAMAGE
	and not (player.pflags & (PF_THOKKED|PF_SHIELDABILITY))
	and mo.momz*P_MobjFlip(mo) >= 0
		player.pirolisquish = SQUISHTIME
		mo.state = S_PLAY_SPRING
		player.panim = PA_JUMP
		mo.tics = -1
	end
	
	//Let go of spin during the needle throw
	if player.pirolipressspin and not (player.cmd.buttons & BT_SPIN)
		player.pirolipressspin = false
	end
	
	//Lockon
	if FixedHypot(player.cmd.forwardmove, player.cmd.sidemove) < 35
	and (P_IsObjectOnGround(mo) or player.pflags & PF_JUMPED)
	and not player.weapondelay and not player.pirolifriction
	and not (player.pflags & PF_STASIS) and not player.exiting
		local enemy = newNeedleLook(player)
		if enemy and enemy.valid
			P_SpawnLockOn(player, enemy, S_LOCKON4)
		end
	end
	
	//Flight time
	if player.glidetime
		player.glidetime = $ - 1
		if not player.glidetime and player.pflags & PF_THOKKED
			player.pflags = $ | PF_THOKKED &~ PF_JUMPED
			P_DoJump(player, false)
			player.pflags = $ &~ PF_STARTJUMP
			
			player.pirolisquish = SQUISHTIME
			pirolicircle(mo, MT_GHOST, 4, 4*mo.scale, player.height/2, mo.scale/2)
		end
	end
	
	//Friction time
	if player.pirolifriction
		if P_IsObjectOnGround(mo)
			mo.friction = max($, FRACUNIT - (FRACUNIT - $)/player.pirolifriction)
		else
			mo.friction = FRACUNIT
			if not (player.pflags & PF_JUMPED)
				player.pflags = $ | P_GetJumpFlags(player)
			end
		end
		player.pirolifriction = $ - 1
		
		if player.pirolifriction & 1
			P_SpawnGhostMobj(mo).colorized = true
		end
	end
	
	//Animation junk
	if player.pirolirunsound and player.panim == PA_RUN
		S_StartSound(mo, sfx_prlrun)
		player.pirolisquish = SQUISHTIME
		player.pirolirunsound = false
	end
	
	//Landing
	if not (P_IsObjectOnGround(mo) or mo.eflags & MFE_JUSTHITFLOOR)
		player.pirolilanding = $ + 1
	elseif player.pirolilanding
		if player.pirolilanding >= 5
			player.pirolisquish = SQUISHTIME
		end
		player.pirolilanding = 0
	end
	
	//End throw
	if mo.state == S_PLAY_MELEE_FINISH
	and (not (player.pirolineedle and player.pirolineedle.valid)
	or not (player.pirolineedle.flags & MF_MISSILE))
		if P_IsObjectOnGround(mo)
			mo.state = S_PLAY_WALK
		else
			mo.state = S_PLAY_JUMP
		end
		
	//Sliding while throwing
	elseif player.panim == PA_ABILITY2
	and P_IsObjectOnGround(mo) and player.speed > 4*mo.scale
		P_SpawnSkidDust(player, mo.radius, true)
		player.pflags = $ | PF_STASIS
		mo.friction = FRACUNIT
		
	//Running flap
	elseif player.panim == PA_RUN
	and mo.tics == 1 and not (mo.frame & FF_FRAMEMASK)
		if P_IsObjectOnGround(mo)
		and (not (mo.eflags & MFE_TOUCHWATER) or mo.eflags & MFE_UNDERWATER)
			pirolicircle(mo, mo.eflags & MFE_UNDERWATER and MT_SMALLBUBBLE or MT_DUST,
			8, 6*mo.scale, 0, mo.scale*2/3, 2)
		end
		player.pirolirunsound = true
	end
	
	//Running angle turn
	local dorollangle = false
	if pirolirollangle.value
	and (player.panim == PA_RUN or mo.state == S_PLAY_TWINSPIN)
		//Calculate angle
		local diff = player.piroliprevdrawangle - player.drawangle
		local limit = max(ANGLE_22h, abs(diff)/4)
		if abs(diff) > ANG1
			local change = ANG2
			if diff > 0 then change = -$ end
			player.pirolirollangle = min(max($ + change, -limit), limit)
		else
			player.pirolirollangle = FixedMul($, FRACUNIT*7/8)
		end
		
		//Calculate angle to rollangle (thanks Golden for sloperollangle)
		if not splitscreen
			if player.pirolirollangle
				local cameraangle = R_PointToAngle(mo.x, mo.y)
				local diff = cameraangle - player.drawangle
				mo.rollangle = FixedMul(player.pirolirollangle, cos(diff))
			else
				mo.rollangle = 0
			end
		end
	elseif player.pirolirollangle
		player.pirolirollangle = 0
		mo.rollangle = 0
	end
	player.piroliprevdrawangle = player.drawangle
end)